<?php

use Budget\Entity\Account;

$ht = $this->module()->getClientModuleConfiguration('budget', 'ht');
$gbcp = $this->module()->getClientModuleConfiguration('budget', 'gbcp');
$evolution = $this->module()->getClientModuleConfiguration('budget', 'evolution');
$incomeTypes = $this->incomeTypes();
$posteIncomeBalances = $this->posteIncomeBalances();

$groups = [];
if ($this->module()->isActive('keyword')) {
	$groups = $this->allowedKeywordGroups('posteIncome', false);
}

?>

<div ng-controller="posteIncomeListController as self" ng-init="self.init(
         '<?= $this->from ?>',
         <?= $this->object ? $this->object->getId() : 'null' ?>,
         <?= str_replace('"', '\'', json_encode($incomeTypes)) ?>,
         <?= str_replace('"', '\'', json_encode($posteIncomeBalances)) ?>
     )">
	<table-builder options="self.options" items="self.posteIncomes" class="table-builder">
		<div class="row">
			<div class="col-sm-4">
				<div class="table-filters little-panel" ng-controller="filterController">
					<h4 class="separator text-center"><?= ucfirst($this->translate('poste_income_entity')) ?></h4>
					<div class="title" data-toggle="collapse" href="#filters-collapsed-poste-incomes">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
					</div>
					<div id="filters-collapsed-poste-incomes" class="body collapse">
						<?= $this->tableFilter('__tb.apiParams.search.data.filters', $this->posteIncomeFilters()); ?>
						<div class="row">
							<div class="col-xs-6">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
							</div>
							<div class="col-xs-6 text-right">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
									<?= $this->icon('search', 'fa-fw') ?>
									<?= $this->translate('table_filter_button') ?>
								</button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="col-sm-4">
				<div class="table-filters little-panel" ng-controller="filterController">
					<h4 class="separator text-center"><?= ucfirst($this->translate('income_entity')) ?></h4>
					<div class="title" data-toggle="collapse" href="#filters-collapsed-income">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
					</div>
					<div id="filters-collapsed-income" class="body collapse">
						<?= $this->tableFilter('self.incomeParams.search.data.filters', $this->incomeFilters());
						?>
						<div class="row">
							<div class="col-xs-6">
								<button class="btn" ng-click="self.resetfullTextSearch(); self.resetIncomeFilters(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
							</div>
							<div class="col-xs-6 text-right">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
									<?= $this->icon('search', 'fa-fw') ?>
									<?= $this->translate('table_filter_button') ?>
								</button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="col-sm-4">
				<h4 class="separator text-center"><?= ucfirst($this->translate('columns')) ?></h4>
				<table-builder-columns></table-builder-columns>
			</div>
		</div>
		<div class="row" ng-show="showChart">
			<div class="col-xs-12">
				<nvd3 options="chart.options" data="chart.data" api="api"></nvd3>
			</div>
		</div>
		<div class="row">
			<div class="col-xs-12">
				<div class="btn-group pull-right">
					<button class="btn btn-lg" ng-click="__tb.removeFromList()" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
						<?= $this->icon('eraser', 'fa-fw pointer') ?>
					</button>
					<button class="btn btn-lg btn-excel" type="button" ng-click="self.showExportExpenseModal()" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
						<?= $this->icon('excel', 'fa-fw pointer') ?>
					</button>
				</div>
				<div class="btn-group pull-right">
					<?php if ($this->acl()->isAllowed('budget:e:posteIncome:c')) : ?>
						<button type="button" class="btn btn-lg" ng-click="self.createPosteIncome()" ng-if="!lockBudget<?= ($this->from === 'project' && $this->acl()->onlyOwned('project:e:project:u') ? ' && self.isManager(' . $this->authStorage()->getUser()->getId() . ')' : '') ?>">
							<?= $this->icon('create') ?>
							<?= $this->translate('poste_income_nav_form'); ?>
						</button>
					<?php endif; ?>
					<button type="button" class="btn btn-lg" ng-click="showChart = !showChart" tooltip="<?= $this->translate('tooltip_show_chart') ?>">
						<i class="fa fa-bar-chart"></i>
					</button>
				</div>
			</div>
		</div>
		<br />
		<div class="row">
			<div class="col-xs-12">
				<form name="posteIncomeForm">
					<div>
						Grouper par :

						<select ng-model="self.groupBy">
						<option ng-value="'poste'"><?= ucfirst($this->translate('income_field_poste')) ?></option>
							<option ng-value="'date'"><?= ucfirst($this->translate('income_field_date')) ?></option>
							<option ng-value="'anneeExercice'"><?= ucfirst($this->translate('income_field_anneeExercice')) ?></option>
							<option ng-value="'bordereau'"><?= ucfirst($this->translate('income_field_bordereau')) ?></option>
							<option ng-value="'mandat'"><?= ucfirst($this->translate('income_field_mandat')) ?></option>
							<option ng-value="'engagement'"><?= ucfirst($this->translate('income_field_engagement')) ?></option>
							<option ng-value="'complement'"><?= ucfirst($this->translate('income_field_complement')) ?></option>
							<option ng-value="'evolution'"><?= ucfirst($this->translate('income_field_evolution')) ?></option>
							<?php if ($gbcp) : ?>
								<option ng-value="'gbcp'"><?= ucfirst($this->translate('budget_gbcp_configuration')) ?></option>
							<?php endif ?>
						</select>
					</div>

					<table table-builder-table class="table table-bordered table-condensed table-hover">
						<thead>
							<tr>
								<th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection" /></th>
								<th tb-column tb-name="tree" class="checkbox-column"></th>

								<th tb-column tb-name="account.name" tb-sortable="true" tb-toggle="true"><?= $this->translate('poste_income_field_account') ?></th>

								<?php if ($gbcp) : ?>
									<th tb-column tb-name="nature.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('poste_income_field_nature') ?>
									</th>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<th tb-column tb-name="organization.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('poste_income_field_organization') ?>
									</th>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<th tb-column tb-name="destination.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('poste_income_field_destination') ?>
									</th>
								<?php endif ?>

								<?php if ($this->acl()->isAllowed('budget:e:managementUnit:r')) : ?>
									<th tb-column tb-name="managementUnit.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('management_unit_entity') ?>
									</th>
								<?php endif ?>

								<th tb-column tb-name="envelope.name" tb-sortable="true" tb-toggle="true"><?= $this->translate('poste_income_field_envelope') ?></th>
								<th tb-column tb-name="financer.name" tb-sortable="true" tb-toggle="true"><?= $this->translate('envelope_field_financer') ?></th>
								<th tb-column tb-name="name" tb-sortable="true" tb-toggle="true"><?= $this->translate('poste_income_field_name') ?></th>
								<th tb-column tb-name="project.name" tb-sortable="false" tb-toggle="true"><?= ucfirst($this->translate('project_entity')) ?></th>
								<?php if ($this->module()->isActive('keyword')) {
									foreach ($groups as $group) {
										echo '<th tb-column tb-name="keyword' . $group->getId() . '" tb-sortable="false" tb-toggle="true">' . $group->getName() . '</th>';
									}
								} ?>
								<th tb-column tb-name="percentage" tb-sortable="false" tb-toggle="true">%</th>
								<th tb-column tb-name="amount" tb-sortable="true" tb-toggle="true"><?= $this->translate('poste_income_field_amount') ?></th>

								<?php if ($ht) : ?>
									<th tb-column tb-name="amountHT" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_amountHT') ?></th>
								<?php endif ?>

								<th tb-column tb-name="amountArbo" tb-sortable="false" tb-toggle="true"><?= $this->translate('poste_income_field_amountArbo') ?></th>

								<?php if ($ht) : ?>
									<th tb-column tb-name="amountHTArbo" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_amountHTArbo') ?></th>
								<?php endif ?>

								<th tb-column tb-name="amountAggreg" tb-sortable="false" tb-toggle="true"><?= $this->translate('poste_income_field_amountAggreg') ?></th>

								<?php if ($ht) : ?>
									<th tb-column tb-name="amountHTAggreg" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_amountHTAggreg') ?></th>
								<?php endif ?>

								<?php foreach ($incomeTypes as $type) : ?>
									<th tb-column tb-name="computed.amountArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-sortable="true">
										<?= $this->translate('income_type_' . $type) ?>
									</th>

									<?php if ($ht) : ?>
										<th tb-column tb-name="computed.amountHTArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-sortable="true" tb-hidden="true">
											<?= $this->translate('income_type_' . $type . '_ht') ?>
										</th>
									<?php endif ?>
								<?php endforeach ?>

								<?php foreach ($posteIncomeBalances as $balance) : ?>
									<th tb-column tb-name="amountArbo<?= ucfirst($balance) ?>" tb-toggle="true" tooltip="<?= $this->translate('poste_income_formule_' . $balance) ?>">
										<?= $this->translate('poste_income_balance_' . $balance) ?>
									</th>

									<?php if ($ht) : ?>
										<th tb-column tb-name="amountHTArbo<?= ucfirst($balance) ?>" tb-toggle="true" tb-hidden="true" tooltip="<?= $this->translate('poste_income_formule_' . $balance) ?>">
											<?= $this->translate('poste_income_balance_' . $balance . '_ht') ?>
										</th>
									<?php endif ?>
								<?php endforeach ?>

								<th tb-column tb-name="subventionAmount" tb-sortable="false" tb-toggle="true"><?= $this->translate('poste_income_field_subventionAmount') ?></th>
								<?php if ($ht) : ?>
									<th tb-column tb-name="subventionAmountHT" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_subventionAmountHT') ?></th>
								<?php endif ?>
								<th tb-column tb-name="incomes.convention" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_convention') ?></th>
								<th tb-column tb-name="incomes.conventionTitle" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_conventionTitle') ?></th>
								<th tb-column tb-name="incomes.tiers" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_tiers') ?></th>
								<th tb-column tb-name="incomes.anneeExercice" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_anneeExercice') ?></th>
								<th tb-column tb-name="incomes.bordereau" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_bordereau') ?></th>
								<th tb-column tb-name="incomes.mandat" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_mandat') ?></th>
								<th tb-column tb-name="incomes.engagement" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_engagement') ?></th>
								<th tb-column tb-name="incomes.complement" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_complement') ?></th>
								<th tb-column tb-name="incomes.serie" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_serie') ?></th>
								<th tb-column tb-name="incomes.date" tb-sortable="true" tb-toggle="true"><?= $this->translate('income_field_date') ?></th>
								<th tb-column tb-name="caduciteStart" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_caduciteStart') ?></th>
								<th tb-column tb-name="caduciteEnd" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_caduciteEnd') ?></th>
								<th tb-column tb-name="caduciteSendProof" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_caduciteSendProof') ?></th>
								<th tb-column tb-name="folderSendingDate" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_folderSendingDate') ?></th>
								<th tb-column tb-name="folderReceiptDate" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_folderReceiptDate') ?></th>
								<th tb-column tb-name="deliberationDate" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_deliberationDate') ?></th>
								<th tb-column tb-name="arrDate" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_arrDate') ?></th>
								<th tb-column tb-name="arrNumber" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_arrNumber') ?></th>

								<?php if ($evolution) : ?>
									<th tb-column tb-name="incomes.evolution" tb-toggle="true">
										<?= $this->translate('income_field_evolution') ?>
									</th>
									<th tb-column tb-name="incomes.transfer.name" tb-toggle="true">
										<?= $this->translate('income_field_project_report') ?>
									</th>
								<?php endif ?>

								<th tb-column tb-name="createdAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_createdAt') ?></th>
								<th tb-column tb-name="updatedAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_income_field_updatedAt') ?></th>
								<th tb-column tb-name="actions" class="actions-column"></th>
							</tr>
						</thead>
						<tbody></tbody>
						<tbody ng-repeat="posteIncome in self.posteIncomes">
							<tr ng-class="{
                                    editing: self.editedLine == posteIncome && posteIncome.id != 'total',
                                    pointer: self.editedLine !== posteIncome && posteIncome.id != 'total',
                                    group: self.editedLine !== posteIncome && posteIncome.id != 'total',
                                    footer: posteIncome.id == 'total',
                                    dashed: posteIncome.id !== 'total' && posteIncome.project.id !== self.from.id
                                }" ng-click="showPoste = self.editedLine == posteIncome ? showPoste : !showPoste">
								<td><input type="checkbox" ng-model="posteIncome.selected" /></td>
								<td>
									<i class="fa fa-caret-right pointer" ng-class="{'fa-caret-right' : !showPoste, 'fa-caret-down' : showPoste}" ng-show="posteIncome.incomesArbo.length > 0"></i>
								</td>

								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome && posteIncome.id != 'total'">
										<span ng-if="posteIncome.account">
											<?php if ($this->acl()->isAllowed('budget:e:account:r')) : ?>
												<a href="<?= $this->url('budget/account/form') ?>/{{posteIncome.account.id}}">{{posteIncome.account.code}} - {{posteIncome.account.name}}</a>
											<?php else : ?>
												{{posteIncome.account.code}} - {{posteIncome.account.name}}
											<?php endif; ?>
										</span>

										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<account-select name="account" ng-model="self.editedLineFields.account" form="posteIncomeForm" configuration="{
                                        service: {
                                            apiParams: {
                                                search: {
                                                    data: {
                                                        filters: {
                                                            type: {
                                                                op: 'eq',
                                                                val: '<?= Account::TYPE_INCOME ?>'
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }"></account-select>
										<field-errors field="account" errors="self.errors.fields"></field-errors>
									</span>
								</td>

								<?php if ($gbcp) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== posteIncome && posteIncome.id != 'total'">
											<span ng-if="posteIncome.nature">
												<?php if ($this->acl()->isAllowed('budget:e:nature:r')) : ?>
													<a href="<?= $this->url('budget/nature/form') ?>/{{posteIncome.nature.id}}">
														{{posteIncome.nature.code}} - {{posteIncome.nature.name}}
													</a>
												<?php else : ?>
													{{posteIncome.nature.code}} - {{posteIncome.nature.name}}
												<?php endif ?>
											</span>

											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteIncome">
											<nature-select name="nature" ng-model="self.editedLineFields.nature" form="posteIncomeForm"></nature-select>
											<field-errors field="nature" errors="self.errors.fields"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== posteIncome && posteIncome.id != 'total'">
											<span ng-if="posteIncome.organization">
												<?php if ($this->acl()->isAllowed('budget:e:organization:r')) : ?>
													<a href="<?= $this->url('budget/organization/form') ?>/{{posteIncome.organization.id}}">
														{{posteIncome.organization.code}} - {{posteIncome.organization.name}}
													</a>
												<?php else : ?>
													{{posteIncome.organization.code}} - {{posteIncome.organization.name}}
												<?php endif ?>
											</span>

											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteIncome">
											<organization-select name="organization" ng-model="self.editedLineFields.organization" form="posteIncomeForm"></organization-select>
											<field-errors field="organization" errors="self.errors.fields"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== posteIncome && posteIncome.id != 'total'">
											<span ng-if="posteIncome.destination">
												<?php if ($this->acl()->isAllowed('budget:e:destination:r')) : ?>
													<a href="<?= $this->url('budget/destination/form') ?>/{{posteIncome.destination.id}}">
														{{posteIncome.destination.code}} - {{posteIncome.destination.name}}
													</a>
												<?php else : ?>
													{{posteIncome.destination.code}} - {{posteIncome.destination.name}}
												<?php endif ?>
											</span>

											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteIncome">
											<destination-select name="destination" ng-model="self.editedLineFields.destination" form="posteIncomeForm"></destination-select>
											<field-errors field="destination" errors="self.errors.fields"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<?php if ($this->acl()->isAllowed('budget:e:managementUnit:r')) : ?>
									<td></td>
								<?php endif ?>

								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										<?php if ($this->acl()->isAllowed('budget:e:envelope:r')) : ?>
											<a href="<?= $this->url('budget/envelope/form') ?>/{{posteIncome.envelope.id}}">{{posteIncome.envelope.name}}</a>
										<?php else : ?>
											{{posteIncome.envelope.name}}
										<?php endif; ?>
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<envelope-select name="envelope" ng-model="self.editedLineFields.envelope" required="true" form="posteIncomeForm"></envelope-select>
										<field-errors field="envelope" errors="self.errors.fields"></field-errors>
									</span>
								</td>
								<td>
									<?php if ($this->acl()->isAllowed('directory:e:structure:r')) : ?>
										<a href="<?= $this->url('directory/structure/form') ?>/{{posteIncome.envelope.financer.id}}">{{posteIncome.envelope.financer.name}}</a>
									<?php else : ?>
										{{posteIncome.envelope.financer.name}}
									<?php endif; ?>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{posteIncome.name}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" />
										<field-errors field="name" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td>
									{{ posteIncome.project.name }}
								</td>
								<?php if ($this->module()->isActive('keyword')) {
									foreach ($groups as $group) {
										echo '<td class="editable">';
										echo '<span class="comma-separated" ng-show="self.editedLine !== posteIncome">';
										echo '<span ng-repeat="keyword in posteIncome.keywords[' . $group->getId() . ']">{{keyword.name}}</span>';
										echo $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']);
										echo '</span>';
										echo '<span ng-if="self.editedLine == posteIncome">';
										echo '<keyword-select ng-model="self.editedLineFields.keywords[' . $group->getId() . ']" multiple="' . ($group->isMultiple() ? 'true' : 'false') . '" configuration="{ service : { apiParams : { search: { data: { filters: { group : { op: \'eq\', val: ' . $group->getId() . ' } } } } } } }" form="indicatorForm"></keyword-select>';
										echo '</span>';
										echo '</td>';
									}
								} ?>
								<td>
									<span ng-if="posteIncome.id != 'total'">
										{{(posteIncome.amount * 100 / self.total.amount) | number : 1 }}%
									</span>
								</td>

								<td class="editable text-right">
									<span ng-show="self.editedLine !== posteIncome">
										{{posteIncome.amount | currency : ''}} €
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" name="amount" class="form-control input-sm" autocomplete="off" input-mask="decimal" ng-model="self.editedLineFields.amount" />
										<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>

								<?php if ($ht) : ?>
									<td class="editable text-right">
										<span ng-show="self.editedLine !== posteIncome">
											{{posteIncome.amountHT | currency : ''}} €
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteIncome">
											<input type="text" name="amountHT" class="form-control input-sm" autocomplete="off" input-mask="decimal" ng-model="self.editedLineFields.amountHT" />
											<field-errors field="amountHT" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<td class="text-right">{{ posteIncome.amountArbo | currency : '' }}&nbsp;€</td>

								<?php if ($ht) : ?>
									<td class="text-right">{{ posteIncome.amountHTArbo | currency : '' }}&nbsp;€</td>
								<?php endif ?>

								<td class="text-right">{{ posteIncome.amountAggreg | currency : '' }}&nbsp;€</td>

								<?php if ($ht) : ?>
									<td class="text-right">{{ posteIncome.amountHTAggreg | currency : '' }}&nbsp;€</td>
								<?php endif ?>

								<?php foreach ($incomeTypes as $type) : ?>
									<td class="text-right">
										{{posteIncome.amountArbo<?= ucfirst($type) ?> | currency : ''}} €
									</td>

									<?php if ($ht) : ?>
										<td class="text-right">
											{{posteIncome.amountHTArbo<?= ucfirst($type) ?> | currency : ''}} €
										</td>
									<?php endif ?>
								<?php endforeach ?>

								<?php foreach ($posteIncomeBalances as $balance) : ?>
									<td class="text-right">
										{{posteIncome.amountArbo<?= ucfirst($balance) ?> | currency : ''}} €
									</td>

									<?php if ($ht) : ?>
										<td class="text-right">
											{{posteIncome.amountHTArbo<?= ucfirst($balance) ?> | currency : ''}} €
										</td>
									<?php endif ?>
								<?php endforeach ?>
								<td class="text-right">
									{{ posteIncome.subventionAmount | currency : '' }}
									{{ posteIncome.id !== 'total' ? '€' : '' }}
								</td>
								<?php if ($ht) : ?>
									<td class="text-right">
										{{ posteIncome.subventionAmountHT | currency : '' }}
										{{ posteIncome.id !== 'total' ? '€' : '' }}
									</td>
								<?php endif ?>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.caduciteStart | dateFormat : 'DD/MM/YYYY' }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" input-mask="qdate" class="form-control input-sm" ng-model="self.editedLineFields.caduciteStart" />
										<field-errors field="caduciteStart" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.caduciteEnd | dateFormat : 'DD/MM/YYYY' }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" input-mask="qdate" class="form-control input-sm" ng-model="self.editedLineFields.caduciteEnd" />
										<field-errors field="caduciteEnd" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.caduciteSendProof | dateFormat : 'DD/MM/YYYY' }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" input-mask="qdate" class="form-control input-sm" ng-model="self.editedLineFields.caduciteSendProof" />
										<field-errors field="caduciteSendProof" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.folderSendingDate | dateFormat : 'DD/MM/YYYY' }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" input-mask="qdate" class="form-control input-sm" ng-model="self.editedLineFields.folderSendingDate" />
										<field-errors field="folderSendingDate" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.folderReceiptDate | dateFormat : 'DD/MM/YYYY' }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" input-mask="qdate" class="form-control input-sm" ng-model="self.editedLineFields.folderReceiptDate" />
										<field-errors field="folderReceiptDate" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.deliberationDate | dateFormat : 'DD/MM/YYYY' }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" input-mask="qdate" class="form-control input-sm" ng-model="self.editedLineFields.deliberationDate" />
										<field-errors field="deliberationDate" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.arrDate | dateFormat : 'DD/MM/YYYY' }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" input-mask="qdate" class="form-control input-sm" ng-model="self.editedLineFields.arrDate" />
										<field-errors field="arrDate" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== posteIncome">
										{{ posteIncome.arrNumber }}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteIncome)', 'ng-if' => 'posteIncome._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteIncome">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.arrNumber" />
										<field-errors field="arrNumber" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>

								<?php if ($evolution) : ?>
									<td></td>
									<td></td>
								<?php endif ?>

								<td>{{posteIncome.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td>{{posteIncome.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine != posteIncome">
										<?php if ($this->acl()->isAllowed('budget:e:income:c')) : ?>
											<a class="btn btn-xs btn-default" ng-click="self.createIncome(posteIncome);" ng-if="posteIncome.id != 'total' && !lockBudget && posteIncome._rights.update" tooltip="<?= $this->translate('income_nav_form') ?>">
												<?= $this->icon('create') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:posteIncome:r')) : ?>
											<a ng-if="posteIncome._rights.read" class="btn btn-xs btn-default" ng-click="self.editPosteIncome(posteIncome);" tooltip="<?= $this->translate('tooltip_edit') ?>">
												<?= $this->icon('edit') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:posteIncome:d')) : ?>
											<a ng-if="posteIncome._rights.delete && !lockBudget" ng-click="self.deletePosteIncome(posteIncome);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
												<?= $this->icon('delete') ?>
											</a>
										<?php endif; ?>
									</div>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine == posteIncome">
										<button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(posteIncome, 'poste')" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
											<?= $this->icon('save') ?>
										</button>
										<button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
											<?= $this->icon('close') ?>
										</button>
									</div>
								</td>
							</tr>
							<tr ng-repeat="income in posteIncome.incomesArbo" ng-show="showPoste" ng-class="{
                                editing: self.editedLine == income,
                                dashed: income.project.id !== self.from.id
                            }">
								<td></td>
								<td>
									<?php if ($this->module()->isActive('age')) : ?>
										<i class="fa fa-cloud-upload" ng-if="income.age" tooltip="Importé via AGE"></i>
									<?php endif; ?>
								</td>

								<td></td>

								<?php if ($gbcp) : ?>
									<td>
										<span ng-show="self.groupBy !== 'poste'">
											{{ income.nature.code ? income.nature.code + ' -' : '' }}
											{{ income.nature.name }}
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td>
										<span ng-show="self.groupBy !== 'poste'">
											{{ income.organization.code ? income.organization.code + ' -' : '' }}
											{{ income.organization.name }}
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td>
										<span ng-show="self.groupBy !== 'poste'">
											{{ income.destination.code ? income.destination.code + ' -' : '' }}
											{{ income.destination.name }}
										</span>
									</td>
								<?php endif ?>

								<?php if ($this->acl()->isAllowed('budget:e:managementUnit:r')) : ?>
									<td>
										{{ income.managementUnit.code ? income.managementUnit.code + ' -' : '' }}
										{{ income.managementUnit.name }}
									</td>
								<?php endif ?>

								<td></td>
								<td></td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.name}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" />
										<field-errors field="name" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td>
									<?php if ($this->acl()->isAllowed('project:e:project:r')) : ?>
										<a href="<?= $this->url('project/form') ?>/{{income.project.id}}">{{income.project.name}}</a>
									<?php else : ?>
										{{income.project.name}}
									<?php endif; ?>
								</td>
								<?php if ($this->module()->isActive('keyword')) {
									foreach ($groups as $group) {
										echo '<td></td>';
									}
								} ?>
								<td></td>

								<td></td>
								<td></td>
								<td></td>

								<?php if ($ht) : ?>
									<td></td>
									<td></td>
									<td></td>
								<?php endif ?>

								<?php foreach ($incomeTypes as $type) : ?>
									<td class="editable text-right">
										<span ng-show="self.editedLine !== income">
											{{income.type == '<?= $type ?>' ? (income.amount | currency : '') + ' €' : '' }}
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => 'income.type == \'' . $type . '\' && !lockBudget && income._rights.update']) ?>
										</span>
										<span ng-if="self.editedLine == income && income.type == '<?= $type ?>'">
											<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amount" required input-mask="decimal" ng-readonly="income.age" />
											<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>

									<?php if ($ht) : ?>
										<td class="editable text-right">
											<span ng-show="self.editedLine !== income">
												{{income.type == '<?= $type ?>' ? (income.amountHT | currency : '') + ' €' : '' }}
												<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => 'income.type == \'' . $type . '\' && !lockBudget && income._rights.update']) ?>
											</span>
											<span ng-if="self.editedLine == income && income.type == '<?= $type ?>'">
												<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amountHT" required input-mask="decimal" />
												<field-errors field="amountHT" errors="self.editedLineErrors"></field-errors>
											</span>
										</td>
									<?php endif ?>
								<?php endforeach ?>

								<?php foreach ($posteIncomeBalances as $balance) : ?>
									<td></td>

									<?php if ($ht) : ?>
										<td></td>
									<?php endif ?>
								<?php endforeach; ?>

								<td></td>
								<?php if ($ht) : ?>
									<td></td>
								<?php endif ?>

								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.convention}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.convention" />
										<field-errors field="convention" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.conventionTitle}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.conventionTitle" ng-readonly="income.age" />
										<field-errors field="conventionTitle" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.tiers}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.tiers" ng-readonly="income.age" />
										<field-errors field="tiers" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.anneeExercice}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.anneeExercice" ng-readonly="income.age" />
										<field-errors field="anneeExercice" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.bordereau}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.bordereau" />
										<field-errors field="bordereau" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.mandat}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.mandat" />
										<field-errors field="mandat" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.engagement}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.engagement" ng-readonly="income.age" />
										<field-errors field="engagement" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.complement}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.complement" />
										<field-errors field="complement" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.serie}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.serie" />
										<field-errors field="serie" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== income">
										{{income.date | dateFormat : 'DD/MM/YYYY'}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(income)', 'ng-if' => '!lockBudget && income._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == income">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.date" required input-mask="qdate" ng-readonly="income.age" />
										<field-errors field="date" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>

								<?php if ($evolution) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== income">
											{{ income.evolution ? 'Oui' : 'Non' }}

											<?= $this->icon('inline-edit', '', [
												'ng-click' => 'self.editLine(income)',
												'ng-if' => '!lockBudget && income._rights.update'
											]) ?>
										</span>

										<span ng-if="self.editedLine == income">
											<input type="checkbox" class="form-control input-sm" ng-model="self.editedLineFields.evolution" />
											<field-errors field="evolution" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>
									<td>
										<span ng-if="income.transfer" title="{{ income.transfer.name }}"><a href="{{income.transfer.id}}">{{ income.transfer.code }}</a></span>
									</td>
								<?php endif ?>

								<td>{{income.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td>{{income.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td class="text-right">
									<div class="btn-group btn-group-actions" ng-if="self.editedLine != income">
										<?php if ($this->acl()->isAllowed('budget:e:income:u')) : ?>
											<a class="btn btn-xs btn-default" ng-click="self.editIncome(income, posteIncome);" tooltip="<?= $this->translate('tooltip_edit') ?>">
												<?= $this->icon('edit') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:income:c')) : ?>
											<a class="btn btn-xs btn-default" ng-click="self.duplicateIncome(income, posteIncome);" tooltip="<?= $this->translate('tooltip_copy') ?>">
												<?= $this->icon('duplicate') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:income:d')) : ?>
											<a ng-if="!lockBudget && income._rights.update" ng-click="self.deleteIncome(income, posteIncome);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
												<?= $this->icon('delete') ?>
											</a>
										<?php endif; ?>
									</div>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine == income">
										<button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(income, 'income', posteIncome)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
											<?= $this->icon('save') ?>
										</button>
										<button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
											<?= $this->icon('close') ?>
										</button>
									</div>
								</td>
							</tr>
						</tbody>
					</table>
				</form>
			</div>
		</div>
	</table-builder>
	<div class="modal" id="exportExcelModal4">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<h4 class="modal-title"><?= $this->translate('project_exportExcel_module_title') ?></h4>
				</div>
				<div class="modal-body">
					<div class="row">
						<div class="col-xs-12">
							<select class="form-control" ng-model="self.exportModel">
								<option value="default"><?= $this->translate('project_export_default') ?></option>
								<?php if (count($this->incomeCustomExportsExcel) > 0) : ?>
									<optgroup label="<?= ucfirst($this->translate('export_custom_entity')) ?>">

										<?php foreach ($this->incomeCustomExportsExcel as $export) : ?>
											<option value="<?= $export->getKey() ?>">
												<?= $export->getName() ?>
											</option>
										<?php endforeach; ?>

									</optgroup>
								<?php endif; ?>
							</select>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button class="btn btn-default" type="button" data-dismiss="modal">
						<?= $this->translate('close') ?>
					</button>

					<button class="btn btn-submit" ng-disabled="self.loading.export || !self.exportModel" ng-click="self.export('<?= ucfirst(\Export\Entity\Export::TYPE_EXCEL) ?>')">
						<?= $this->icon('loading', '', ['ng-if' => 'self.loading.export']) ?>
						<?= $this->translate('export') ?>
					</button>

					<form id="exportExcelForm4" action="<?= $this->url('project/tree') ?>" method="POST" target="_blank">
						<input type="hidden" name="export" value="{{self.exportModel}}" />
						<input type="hidden" name="filters" value="{{self.exportFilters}}" />
					</form>
				</div>
			</div>
		</div>
	</div>

	<?= $this->partial('budget/partial/poste-income/form.phtml', ['from' => $this->from, 'object' => $this->object]) ?>
	<?= $this->partial('budget/partial/income/form.phtml', ['from' => $this->from, 'object' => $this->object]) ?>
</div>